<?php

namespace NoccyLabs\Mattermost\DialogBuilder\Element;

use JsonSerializable;

class TextElement extends AbstractElement
{
    const TYPE_TEXT = 'text';
    const TYPE_NUMBER = 'number';
    const TYPE_PASSWORD = 'password';
    const TYPE_TEL = 'tel';
    const TYPE_URL = 'url';

    private ?string $type = null;

    private ?int $minLength = null;

    private ?int $maxLength = null;

    private ?string $placeholder = null;


    public function buildElement(): array
    {
        $el = $this->makeElement('text');
        
        if ($this->type !== null) $el['subtype'] = (string)$this->type;
        if ($this->minLength !== null) $el['min_length'] = (int)$this->minLength;
        if ($this->maxLength !== null) $el['max_length'] = (int)$this->maxLength;
        if ($this->placeholder !== null) $el['min_length'] = (string)$this->minLength;

        return $el;
    }

}

